
------Variables
local lang_FltLg
local Flts_ver

local file
local files = {}
local filesIndex = 1
local expfile



local Tele1_w, Tele1_h
local Flts_Day, Lnchs_Day, Flts_Tot, Lnchs_Tot

local Flts_Year, Lnchs_Year, Year, Season_txt = {}, {}, {}, {}   --#1- --> Current Year!!
                                                                  --Only #1-#8 will be stored to Model file
                                                                  --#11, #12, etc. will be used for Data Import from txt File
local Flts_txt, Lnchs_txt = {"","",""}, {"","",""}                --#1 FltLgTele1 / #2 FltLgTele2 Window  / #3 Last Time Flights

local Flts_sw, Lnchs_sw

local Flts_Counted, Lnchs_Counted = false, false
local f3k, f3k_index, bkp, viewlast

local date_start, date_startImport, year_now, Seasons

local date_txt = {"",""}                                        --#1 FltLgTele1 & FltLgTele2 Window  / #3 Last Time Flights

local getTextWidth = lcd.getTextWidth
local drawText = lcd.drawText
local drawLine = lcd.drawLine

--APP Testing----------------------------------------
--[[
  -- EMU Date allways 1.3.2012
  local emu_day, emu_mon, emu_year
--]]
--APP Testing----------------------------------------




--------------------------------------------------------------------------------
-- Read TRANSLATION
local function getTranslation()
  local trans = system.getLocale()
  local file  = io.readall("Apps/FlightsLog/Lang/FlightsLog.jsn")
  local dec_file = json.decode(file)

  if (dec_file) then
    lang_FltLg = dec_file[trans] or dec_file[dec_file.default]
  end

collectgarbage()
end


-- Read TRANSLATION
--------------------------------------------------------------------------------





--------------------------------------------------------------------------------
-- App Functions
-- Findout Tablelenght
function tablelength(T)
  local count = 0

  for i in pairs(T) do
    count = count + 1
  end

  collectgarbage()
  return count
end


-- Format Integer to String with spaces before if k==true one more space will be adde

local function convert(x, k)
local testnum = tonumber(x) --test when x ist not a number
                            --to prevent App crashing!!
  if (testnum~=nil) then
    if (k==false) then
      if (x<10) then
        x = "    "..x                -- 1 -  9
      elseif (x>9 and x<100) then
        x = "  "..x                  --10 - 99
      end
    else
      if (x<10) then
        x = "      "..x                --  1 -   9
      elseif (x>9 and x<100) then
        x = "    "..x                 -- 10 -  99
      elseif (x>99 and x<1000) then
        x = "  "..x                  --100 - 999
      end
    end
  else  --when x not number!!
    x = "      0"
  end

  collectgarbage()
  return x
end


local function exportLogData() --Exports the FlightLog
  if (expfile~="") then
    local yn = form.question(lang_FltLg.confirm, "", lang_FltLg.overwrite1, 10000, false, 500)

    if (yn==1) then
      local write = io.write

      expfile = expfile..".txt" --to report in the SubForm 2, that the Log was exported!!

      file = "Apps/FlightsLog/"..expfile
      file = io.open(file, "w")

      write(file, lang_FltLg.since..date_start, "\n")
      write(file, "\n")
      write(file, lang_FltLg.flts..Flts_Tot, "\n")
      if (f3k==true) then write(file, lang_FltLg.lnchs..Lnchs_Tot, "\n") end
      write(file, "\n")

      if (bkp==false) then
        for i = 1, 8 do
          if (Year[i]~="" and Year[i]~=nil and f3k==false) then
            write(file, Year[i]..": "..lang_FltLg.f..Flts_Year[i], "\n")
          end
          if (Year[i]~="" and Year[i]~=nil and f3k==true) then
            write(file, Year[i]..": "..lang_FltLg.f..Flts_Year[i], "\t", lang_FltLg.l..Lnchs_Year[i], "\n")
          end
        end --i = 1, 8
      elseif (bkp==true) then
        --FIRST: Export everything BUT not the current year
        for i = 11, 11+Seasons do
          if (Year[i]~="" and Year[i]~=nil and f3k==false) then
            write(file, Year[i]..": "..lang_FltLg.f..Flts_Year[i], "\n")
          end
          if (Year[i]~="" and Year[i]~=nil and f3k==true) then
            write(file, Year[i]..": "..lang_FltLg.f..Flts_Year[i], "\t", lang_FltLg.l..Lnchs_Year[i], "\n")
          end
        end --i = 11, 11+Seasons

        --NOW, Export the CURRENT Year
        if (Year[1]~="" and Year[1]~=nil and f3k==false) then
          write(file, Year[1]..": "..lang_FltLg.f..Flts_Year[1], "\n")
        end
        if (Year[1]~="" and Year[1]~=nil and f3k==true) then
          write(file, Year[1]..": "..lang_FltLg.f..Flts_Year[1], "\t", lang_FltLg.l..Lnchs_Year[1], "\n")
        end

      end --bkp==false

      io.close(file)
      file = "" --clear variable after using

    end --yn==1

  else --Warning incase of no filename given in the SubForm 2
    system.messageBox(lang_FltLg.expwarning, 2)
  end --file~=""

form.reinit(2)
collectgarbage()

end



local function importLogData(filePath) --Returns the number of imported Years
  local readline = io.readline
  local gmatch = string.gmatch
  local line, number, l, n

  file = io.open(filePath, "r")

  date_startImport = readline(file) --First Line of File contains the Startdate

  l = 0
  repeat
    l = l + 1

    --clear old Imported Data
    Year[10+l] = nil
    Flts_Year[10+l] = ""
    Lnchs_Year[10+l] = ""

    line = readline(file)

    n = 0
    if (line) then

      for number in gmatch(line, "%d+") do
        n = n + 1

        --load new Imported Data
        if (n==1) then Year[10+l] = tonumber(number) end
        if (n==2) then Flts_Year[10+l] = tonumber(number) end
        if (n==3) then Lnchs_Year[10+l] = tonumber(number) end

      end
    end

  until (not line)

  io.close(file)
collectgarbage()
return (l-1)
end

local function newLogData(filePath,offset)   --All file contents will be erased
                                             --and refilled with new Logs
  local write = io.write                     --If offset==FALSE only #1-#8 will be saved
  local i                                    --If offset==TRUE only #11,#12,#13, exc will be saved

  --Load everything from Backup to Flts_Year, Lnchs_Year, Year [11], [12], [13] etc
  --before new BkpFile is created when More than 8 Seasons(BKP been used) are saved
--[[
  if (bkp==true and offset==true) then
    s=importLogData(filePath)
    for i=10, 15+s do print(s,i, Year[i], Flts_Year[i], Lnchs_Year[i]) end
  end --bkp==true
--]]


  file = io.open(filePath, "w")

  if (offset==false) then
    if (file) then
      write(file, date_start, "\n")

      for i = 8, 1, -1 do --Only different years then the actual one (year_now) will be stored to newLogData
                          --The actual Year will be later stored when the year changes --> Diff Year during Init
          if (Year[i]~="" and Year[i]~=nil and Flts_Year[i]~="" and Flts_Year[i]~=nil and f3k==false) then
            if (Year[i]~=year_now) then write(file, Year[i]..": "..Flts_Year[i], "\n") end
          elseif (Year[i]~="" and Year[i]~=nil and Flts_Year[i]~=nil and Lnchs_Year[i]~=nil and f3k==true) then
            if (Lnchs_Year[i]=="") then Lnchs_Year[i] = 0 end --when changing between f3k & not f3k mode sometimes
                                                              --became empty --> save 0 instead of empty
            if (Year[i]~=year_now) then write(file, Year[i]..": "..Flts_Year[i].." "..Lnchs_Year[i], "\n") end
          end
      end

    end

  elseif (offset==true) then
    write(file, date_startImport, "\n")

    i = 11
    repeat    --Only different years then the actual one (year_now) will be stored to newLogData
              --The actual Year will be later stored when the year changes --> Diff Year during Init
      if (Year[i] and not Lnchs_Year[i]) then --NO Launches Imported
        if (Year[i]~=year_now) then write(file, Year[i]..": "..Flts_Year[i], "\n") end
      elseif (Year[i] and Lnchs_Year[i]) then --WITH Launches Imported
        if (Year[i]~=year_now) then write(file, Year[i]..": "..Flts_Year[i].." "..Lnchs_Year[i], "\n") end
      end

      i = i + 1
    until (not Year[i])

  end

  io.close(file)
collectgarbage()
end


local function saveLineLogData(line)                 --Line value (String) will be written as last Line
  local model = system.getProperty("Model")..".txt"  --in BackupFile

  file = io.open("Apps/FlightsLog/Backups/"..model, "a")
  io.write(file, line, "\n")
  io.close(file)

collectgarbage()
end


local function fileImportChanged(value)

  filesIndex = value
  file = "Apps/FlightsLog/"..files[filesIndex]
  Seasons = importLogData(file)

collectgarbage()
form.reinit(3)
end


local function overwrt()
  local pSave = system.pSave
  local yn = form.question(lang_FltLg.confirm, "", lang_FltLg.overwrite, 10000, false, 1000)
  local model = system.getProperty("Model")..".txt"
  local x = 0

  if (yn==1) then
    if (bkp==true) then
      newLogData("Apps/FlightsLog/Backups/"..model, true)
    end

    --Change f3k Mode depending on imported data (Launches imported, or not)!!
    --to stop App from crashing later on
    if (Lnchs_Year[11]=="") then  --NO Launches Imported
      f3k=false
      pSave("f3k", "false")
    else                          --WITH Launches Imported
      f3k=true
      pSave("f3k", "true")
   end


   --Clear Old data before it gets overwritten
   Flts_Tot = 0
   Lnchs_Tot = 0

   for i = 2, 10 do
     Year[i] = ""
     Flts_Year[i] = ""
     Lnchs_Year[i] = ""
   end


   --Check if current Year appears in imported data
   if (Year[10+Seasons]~=year_now) then --Last Imported year is diff then the current Tx one
     x = 1
     --Retain allready counted Flts & Lnchs when diff Year on Tx/Imported
     Flts_Tot = Flts_Year[1]
     if (f3k==true) then Lnchs_Tot = Lnchs_Year[1] end
   end

   --Do the overwriting
   date_start = date_startImport


   for i = 1, Seasons do
     if (i<9 or bkp==true) then
       Year[i+x] = Year[11+Seasons-i]
       Flts_Year[i+x] = Flts_Year[11+Seasons-i]

       Flts_Tot = Flts_Tot + Flts_Year[11+Seasons-i]
       if (f3k==true) then
         Lnchs_Year[i+x] = Lnchs_Year[11+Seasons-i]

         Lnchs_Tot = Lnchs_Tot +Lnchs_Year[11+Seasons-i]
       end
     end --i<9 or bkp==true

   end --(for i = 1, Seasons)


   --Save everything to Tx
   pSave("date_start", date_start)
   pSave("Flts_Tot", Flts_Tot)
   pSave("Lnchs_Tot", Lnchs_Tot)

   for i = 1, 10 do
     pSave("Year"..i, Year[i])
     pSave("Flts_Year"..i, Flts_Year[i])
     if (f3k==true) then
        pSave("Lnchs_Year"..i, Lnchs_Year[i])
     else
        pSave("Lnchs_Year"..i, "")
     end
   end --i = 1, 10


   --Redoo everything for the Telemetry Windows:
   Flts_txt[1] = lang_FltLg.flts..Flts_Day.." : "..Flts_Tot
   Lnchs_txt[1] = lang_FltLg.lnchs..Lnchs_Day.." : "..Lnchs_Tot
   Flts_txt[2] = lang_FltLg.flts.." "..Flts_Tot
   Lnchs_txt[2] = lang_FltLg.f..Flts_Tot.." "..lang_FltLg.l..Lnchs_Tot
   date_txt[1] = lang_FltLg.since..date_start

   --Text Output for Last Time Flights
   Flts_txt[3] = lang_FltLg.flts..0
   Lnchs_txt[3] = lang_FltLg.lnchs..0
   date_txt[3] = lang_FltLg.last
   pSave("Flts_txt3",Flts_txt[3])
   pSave("Lnchs_txt3",Lnchs_txt[3])
   pSave("date_txt3",date_txt[3])


   for i = 1, 8 do
     if (f3k==false and Year[i]~="") then
       Season_txt[i] = Year[i]..": "..Flts_Year[i]
     elseif (f3k==true and Year[i]~="") then
       Season_txt[i] = Year[i]..":  "..lang_FltLg.f..convert(Flts_Year[i], false).."   "..lang_FltLg.l..convert(Lnchs_Year[i], true)
     end
   end

  filesIndex = 1
  end --of (yn==1)

  form.reinit(3)
collectgarbage()
end


local function expfileChanged(value)
  expfile = value
collectgarbage()
end

-- App Functions
--------------------------------------------------------------------------------



--------------------------------------------------------------------------------
--pSave Data to Model
local function Flts_swChanged(value)
  Flts_sw = value
  system.pSave("Flts_sw", value)
end

local function Flts_TotChanged(value)
  Flts_Tot = value
  system.pSave("Flts_Tot", value)
  Flts_txt[1] = lang_FltLg.flts..Flts_Day.." : "..Flts_Tot
  Flts_txt[2] = lang_FltLg.flts.." "..Flts_Tot
  Lnchs_txt[2] = lang_FltLg.f..Flts_Tot.." "..lang_FltLg.l..Lnchs_Tot
end

local function Flts_Year1Changed(value)
  Flts_Year[1] = value
  system.pSave ("Flts_Year1", value)

  if (f3k==false) then
    Season_txt[1] = Year[1]..": "..Flts_Year[1]
  elseif (f3k==true) then
    Season_txt[1] = Year[1]..":  "..lang_FltLg.f..convert(Flts_Year[1], false).."   "..lang_FltLg.l..convert(Lnchs_Year[1], true)
  end

end

local function date_startChanged(value)
  date_start = value
  system.pSave("date_start", value)
  date_txt[1] = lang_FltLg.since..date_start
end


local function Lnchs_swChanged(value)
  Lnchs_sw = value
  system.pSave("Lnchs_sw", value)
end

local function Lnchs_TotChanged(value)
  Lnchs_Tot = value
  system.pSave("Lnchs_Tot", value)
  Lnchs_txt[1] = lang_FltLg.lnchs..Lnchs_Day.." : "..Lnchs_Tot
  Lnchs_txt[2] = lang_FltLg.f..Flts_Tot.." "..lang_FltLg.l..Lnchs_Tot

  if (f3k==false) then
    Season_txt[1] = Year[1]..": "..Flts_Year[1]
  elseif (f3k==true) then
    Season_txt[1] = Year[1]..":  "..lang_FltLg.f..convert(Flts_Year[1], false).."   "..lang_FltLg.l..convert(Lnchs_Year[1], true)
  end

end

local function Lnchs_Year1Changed(value)
  Lnchs_Year[1] = value
  system.pSave ("Lnchs_Year1", value)
  Season_txt[1] = Year[1]..":  "..lang_FltLg.f..convert(Flts_Year[1], false).."   "..lang_FltLg.l..convert(Lnchs_Year[1], true)
end



local function f3kChanged(value)
  f3k = not value

  if (f3k==true) then
    system.pSave("f3k", "true")
  else
    system.pSave("f3k", "false")
  end

  for i = 1, 8 do
    if (f3k==false and Year[i]~="" and Year[i]~=nil) then
      Season_txt[i] = Year[i]..": "..Flts_Year[i]
    elseif (f3k==true and Year[i]~="" and Year[i]~=nil) then
      Season_txt[i] = Year[i]..":  "..lang_FltLg.f..convert(Flts_Year[i], false).."   "..lang_FltLg.l..convert(Lnchs_Year[i], true)
    end
  end

  --Redoo/Update the BKP-File if bkp==true
  if (bkp==true) then
    file = "Apps/FlightsLog/Backups/"..system.getProperty("Model")..".txt"
    newLogData(file,false)
  end --bkp==true


  form.setValue(f3k_index, f3k)  --Change Checkbox Value
  form.reinit(1)                 --Reinit the Form
end


local function bkpChanged(value)
  local model = system.getProperty("Model")..".txt"
  local yn

    bkp = not value

    if (bkp==true) then
      yn = form.question(lang_FltLg.confirm, "", lang_FltLg.overwrite1, 10000, false, 500)

      if (yn==1) then --Overwrite existing File
        system.pSave("bkp", "true")
        file = "Apps/FlightsLog/Backups/"..model

        newLogData(file,false)
      else            --NO overwrite. Exisiting File will remain
        bkp = false
      end

    else
      system.pSave("bkp", "false")
    end


  form.reinit(1)                 --Reinit the Form
end


local function viewlastChanged(value)
  viewlast = not value

  if (viewlast==true) then
    system.pSave("viewlast", "true")
  else
    system.pSave("viewlast", "false")
  end

  form.reinit(1)                 --Reinit the Form
end
--pSave Data to Model
--------------------------------------------------------------------------------


--------------------------------------------------------------------------------
--Draw App FORM-----------------------------------------------------------------
local function FltLgForm(subform)
  local setButton = form.setButton
  local addRow = form.addRow
  local addSpacer = form.addSpacer
  local addLabel = form.addLabel
  local addInputbox = form.addInputbox
  local addIntbox = form.addIntbox
  local addTextbox = form.addTextbox
  local addCheckbox = form.addCheckbox
  local addSelectbox = form.addSelectbox
  local addLink = form.addLink
  local setFocusedRow = form.setFocusedRow

  local focus


  --SUBFORM 1 -- Settings
  if (subform==1) then
    setButton(1, ":tools", HIGHLIGHTED)
    setButton(2, lang_FltLg.btn2, ENABLED)
    setButton(3, lang_FltLg.btn3, ENABLED)
    setButton(4, lang_FltLg.btn4, ENABLED)


    expfile = "" --for the SubForm2

    addRow(2)
    addSpacer((290 - getTextWidth(FONT_BIG, lang_FltLg.settings))/2 ,1)
    addLabel({label=lang_FltLg.settings, font=FONT_BIG, width=250})
    addSpacer(1,5)

    addLabel({label=lang_FltLg.fltslgr, font=FONT_BOLD, width=250})

    addRow(2)
    addLabel({label=lang_FltLg.selsw, font=FONT_NORMAL, width=250})
    addInputbox(Flts_sw, false, Flts_swChanged)

    addRow(2)
    addLabel({label=lang_FltLg.datecntr, font=FONT_NORMAL, width=200})
    addTextbox(date_start, 15, date_startChanged)
    addSpacer(1,7)

    addRow(2)
    addLabel({label=lang_FltLg.adjusttot, font=FONT_NORMAL, width=250})
    addIntbox(Flts_Tot, 0, 32767, Flts_Tot, 0, 1, Flts_TotChanged)

    addRow(2)
    addLabel({label=lang_FltLg.adjustyrl, font=FONT_NORMAL, width=250})
    addIntbox(Flts_Year[1], 0, 32767, Flts_Year[1], 0, 1, Flts_Year1Changed)
    addSpacer(1,7)

    addRow(2)
    addLabel({label=lang_FltLg.usef3k, font=FONT_NORMAL, width=250})
    f3k_index = addCheckbox(f3k, f3kChanged)
    addLabel({label=lang_FltLg.usef3kwrng, font=FONT_MINI, width=250})
    addLabel({label=lang_FltLg.usef3kwrng1, font=FONT_MINI, width=250})

    addSpacer(1,5)

    if (f3k) then

      addLabel({label=lang_FltLg.lnchlgr, font=FONT_BOLD, width=250})

      addRow(2)
      addLabel({label=lang_FltLg.selsw, font=FONT_NORMAL, width=250})
      addInputbox(Lnchs_sw, false, Lnchs_swChanged)

      addRow(2)
      addLabel({label=lang_FltLg.adjusttot, font=FONT_NORMAL, width=250})
      addIntbox(Lnchs_Tot, 0, 32767, Lnchs_Tot, 0, 1, Lnchs_TotChanged)

      addRow(2)
      addLabel({label=lang_FltLg.adjustyrl, font=FONT_NORMAL, width=250})
      addIntbox(Lnchs_Year[1], 0, 32767, Lnchs_Year[1], 0, 1, Lnchs_Year1Changed)
      addSpacer(1,10)
    end
    addSpacer(1,5)

    addRow(2)
    addLabel({label=lang_FltLg.dsplast, font=FONT_NORMAL, width=250})
    addCheckbox(viewlast, viewlastChanged)

    addSpacer(1,5)

    addRow(2)
    addLabel({label=lang_FltLg.usebkp, font=FONT_NORMAL, width=250})
    addCheckbox(bkp, bkpChanged)
    addLabel({label=lang_FltLg.bkpnote1, font=FONT_MINI, width=250})
    addLabel({label=lang_FltLg.bkpnote2, font=FONT_MINI, width=250})
    addLabel({label=lang_FltLg.bkpnote3, font=FONT_MINI, width=250})
    addSpacer(1,5)

  end


  --SUBFORM 2 -- View Years
  if (subform==2) then

    setButton(1, ":tools", ENABLED)
    setButton(2, lang_FltLg.btn2, HIGHLIGHTED)
    setButton(3, lang_FltLg.btn3, ENABLED)
    setButton(4, lang_FltLg.btn4, ENABLED)


    addRow(2)
    addSpacer((290 - getTextWidth(FONT_BIG, lang_FltLg.view))/2 ,1)
    addLabel({label=lang_FltLg.view, font=FONT_BIG, width=250})
    addSpacer(1,5)

    addLabel({label=lang_FltLg.since..date_start, font=FONT_NORMAL, width=250})
    addSpacer(1,3)

    addLabel({label=lang_FltLg.flts..Flts_Tot, font=FONT_NORMAL, width=250})
    if (f3k==true) then addLabel({label=lang_FltLg.lnchs..Lnchs_Tot, font=FONT_NORMAL, width=250}) end
    addSpacer(1,5)

    if (bkp==false) then
      for i = 1, 8 do
        if (f3k==false and Year[i]~="" and Year[i]~=nil) then
          addRow(1)
          addLabel({label=Year[i]..": "..lang_FltLg.flts..Flts_Year[i], font=FONT_NORMAL})
        elseif (f3k==true and Year[i]~="" and Year[i]~=nil) then
          addRow(1)
          addLabel({label=Year[i]..": "..lang_FltLg.flts..Flts_Year[i].." "..lang_FltLg.lnchs..Lnchs_Year[i], font=FONT_NORMAL})
        end
      end --i = 1, 8
    elseif (bkp==true) then


      --Load Data from Bkp File
      Seasons = importLogData("Apps/FlightsLog/Backups/"..system.getProperty("Model")..".txt")
      for i = 11, 11+Seasons do

        --[[--Test
        print("BKP: ",i, Year[i], Flts_Year[i], Lnchs_Year[i])
        --]]

        if (f3k==false and Year[i]~="" and Year[i]~=nil) then
          addRow(1)
          addLabel({label=Year[i]..": "..lang_FltLg.flts..Flts_Year[i], font=FONT_NORMAL})
        elseif (f3k==true and Year[i]~="" and Year[i]~=nil) then
          addRow(1)
          addLabel({label=Year[i]..": "..lang_FltLg.flts..Flts_Year[i].." "..lang_FltLg.lnchs..Lnchs_Year[i], font=FONT_NORMAL})
        end
      end --i = 1, 8

      --Load ONLY the CURRENT Year
      if (f3k==false and Year[1]~="" and Year[1]~=nil) then
        addRow(1)
        addLabel({label=Year[1]..": "..lang_FltLg.flts..Flts_Year[1], font=FONT_NORMAL})
      elseif (f3k==true and Year[1]~="" and Year[1]~=nil) then
        addRow(1)
        addLabel({label=Year[1]..": "..lang_FltLg.flts..Flts_Year[1].." "..lang_FltLg.lnchs..Lnchs_Year[1], font=FONT_NORMAL})
      end


    end --bkp==false

    --Export

    addSpacer(1,7)
    addLabel({label=lang_FltLg.export, font=FONT_BOLD, width=250})
    addSpacer(1,5)

    addRow(2)
    addLabel({label=lang_FltLg.expfilename, font=FONT_NORMAL, width=200})
    addTextbox(expfile, 15, expfileChanged)
    addLabel({label=lang_FltLg.expnote, font=FONT_MINI, width=250})
    addSpacer(1,5)

    addRow(1)
    addLink(exportLogData, {label= lang_FltLg.explog.."  >>", font=FONT_BOLD, alignRight=true})
    addSpacer(1,5)


    --Report Export of the FlightLog
    if (expfile~="" and expfile~=nil) then

      addRow(2)
      addSpacer((290 - getTextWidth(FONT_BOLD, lang_FltLg.dataexported))/2 ,1)
      addLabel({label=lang_FltLg.dataexported, font=FONT_BOLD, width=250})

      addRow(2)
      addSpacer((290 - getTextWidth(FONT_MINI, expfile))/2 ,1)
      focus = addLabel({label=expfile, font=FONT_MINI, width=250})

      setFocusedRow(focus)

      expfile = "" --clear the variable with the filename
    end

    --[[--Test
    print("Loaded:")
    for i = 1, 12+Seasons do print (i, Year[i], Flts_Year[i], Lnchs_Year[i]) end
    --]]


  end --subform==2


  --SUBFORM 3 -- Import
  if (subform==3) then
    local type
    local extension
    local gmatch = string.gmatch
    local insert = table.insert

    --Crate the Table with all avail TXT-Files
    files = {"..."}
    for file, type in dir("Apps/FlightsLog") do
      if (type=="file") then
        for extension in gmatch(file, "%.%a%a%a") do
          if (extension==".txt") then
            insert (files, file)
          end
        end
      end
    end
    --Crate the Table with all avail TXT-Files

    setButton(1, ":tools", ENABLED)
    setButton(2, lang_FltLg.btn2, ENABLED)
    setButton(3, lang_FltLg.btn3, HIGHLIGHTED)
    setButton(4, lang_FltLg.btn4, ENABLED)


    addRow(2)
    addSpacer((290 - getTextWidth(FONT_BIG, lang_FltLg.import))/2 ,1)
    addLabel({label=lang_FltLg.import, font=FONT_BIG, width=250})
    addSpacer(1,5)

    addRow(1)
    addLabel({label=lang_FltLg.impnote1, font=FONT_MINI})
    addLabel({label=lang_FltLg.impnote2, font=FONT_MINI})
    addLabel({label=lang_FltLg.impnote3, font=FONT_MINI})
    addLabel({label=lang_FltLg.impnote4, font=FONT_MINI})
    addLabel({label=lang_FltLg.impnote5, font=FONT_MINI})
    addSpacer(1,5)
    addRow(1)
    addLabel({label=lang_FltLg.impnote6, font=FONT_MINI})
    addSpacer(1,5)
    addLabel({label=lang_FltLg.impnote7, font=FONT_MINI})
    addLabel({label=lang_FltLg.impnote8, font=FONT_MINI})
    addLabel({label=lang_FltLg.impnote9, font=FONT_MINI})
    addLabel({label=lang_FltLg.impnote10, font=FONT_MINI})
    addSpacer(1,5)

    addRow(2)
    addLabel({label=lang_FltLg.impfile, font=FONT_NORMAL, width=250})
    addSelectbox(files, filesIndex, true, fileImportChanged)
    addSpacer(1,7)

    if (files[filesIndex]~="...") then

      addRow(2)
      addSpacer((290 - getTextWidth(FONT_BOLD, lang_FltLg.dataloaded))/2 ,1)
      addLabel({label=lang_FltLg.dataloaded, font=FONT_BOLD, width=250})

      addRow(2)
      addSpacer((290 - getTextWidth(FONT_MINI, files[filesIndex]))/2 ,1)
      addLabel({label=files[filesIndex], font=FONT_MINI, width=250})

      addSpacer(1,5)

      addRow(2)
      addLabel({label=lang_FltLg.impyears..Seasons, font=FONT_MINI, width=250})
      addSpacer(1,7)

      addRow(1)
      focus = addLabel({label=lang_FltLg.datecntr..": "..date_startImport, font=FONT_NORMAL})
      setFocusedRow(focus)


      for i = 11, (10+Seasons) do
        addRow(1)
          if (Year[i] and Lnchs_Year[i]=="") then --NO Launches Imported
            addLabel({label=Year[i]..": "..lang_FltLg.flts..Flts_Year[i], font=FONT_NORMAL})
          elseif (Year[i] and Lnchs_Year[i]~="") then --WITH Launches Imported
            addLabel({label=Year[i]..": "..lang_FltLg.flts..Flts_Year[i].." "..lang_FltLg.lnchs..Lnchs_Year[i], font=FONT_NORMAL})
          end
      end

      if (bkp==false and Seasons>8) then --Imform that only the first 8 Logs will be imported
        addSpacer(1,5)

        addRow(1)
        addLabel({label=lang_FltLg.impwrn, font=FONT_BOLD})
        addLabel({label=lang_FltLg.impwrn1, font=FONT_MINI})
      end


      addSpacer(1,5)

      addRow(1)
      addLink(overwrt, {label= lang_FltLg.overwrite.."  >>", font=FONT_BOLD, alignRight=true})
      addSpacer(1,5)

    end

  end

  --SUBFORM 4 -- View Years
  if (subform==4) then
    local openExternal = system.openExternal
    local trans = system.getLocale()


    setButton(1, ":tools", ENABLED)
    setButton(2, lang_FltLg.btn2, ENABLED)
    setButton(3, lang_FltLg.btn3, ENABLED)
    setButton(4, lang_FltLg.btn4, HIGHLIGHTED)

    --Open Ifo TXT File depending on Tx Language
    --English is the default Info File if no
    --other is found (ELSE-Part of if-function)
    if (trans=="de") then
      openExternal("Apps/FlightsLog/Info/Info_de.html")
    else
      --openExternal("Apps/FlightsLog/Info/Info.txt")
      openExternal("Apps/FlightsLog/Info/Info_en.html")
    end

    if(key~=KEY_5) then
      form.close()
    end

  end


  addRow(1)
  addLabel({label="by Rodrigo - v." .. Flts_ver, font=FONT_MINI, alignRight=true})

collectgarbage()
end
--Draw App FORM-----------------------------------------------------------------
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
--Re-Init FORM when Functions Buttons F1-F5 are PRESSED
local function keyPressed(key)

  if (key == KEY_1) then  --Settings
    form.reinit(1)
    form.setFocusedRow(1)
  end
  if (key == KEY_2) then  --View Years
    form.reinit(2)
    form.setFocusedRow(1)
  end
  if (key == KEY_3) then  --Import
    form.reinit(3)
    form.setFocusedRow(1)
  end
  if (key == KEY_4) then  --View Apps/FlightsLog Directory
    form.reinit(4)
    form.setFocusedRow(1)
  end

end
--Re-Init FORM when Functions Buttons F1-F5 are PRESSED
--------------------------------------------------------------------------------








--------------------------------------------------------------------------------
--Draw App TELEMETRY WINDOW-----------------------------------------------------
local function FltLgTele1(Tele1_w, Tele1_h)   --Day Flights/Launches + Total
  local txt_w

  if (Tele1_h==24) then   --SMALL Telemetry Window

    if (f3k==false) then
      txt_w = getTextWidth(FONT_BOLD, Flts_txt[1])
      drawText(145-txt_w, 1, Flts_txt[1], FONT_BOLD)
    else
      txt_w = getTextWidth(FONT_MINI, Flts_txt[1])
      drawText(145-txt_w, 0, Flts_txt[1], FONT_MINI)

      txt_w = getTextWidth(FONT_MINI, Lnchs_txt[1])
      drawText(145-txt_w, 10, Lnchs_txt[1], FONT_MINI)
    end

  else                    --BIG Telemetry Window
    if (viewlast==false) then

      if (f3k==false) then
        txt_w = getTextWidth(FONT_BOLD, Flts_txt[1])
        drawText(145-txt_w, 1, Flts_txt[1], FONT_BOLD)
        drawText(3,54, date_txt[1], FONT_MINI)
      else
        txt_w = getTextWidth(FONT_BOLD, Flts_txt[1])
        drawText(145-txt_w, 1, Flts_txt[1], FONT_BOLD)

        txt_w = getTextWidth(FONT_MINI, Lnchs_txt[1])
        drawText(145-txt_w, 20, Lnchs_txt[1], FONT_MINI)

        drawText(3,54, date_txt[1], FONT_MINI)
      end --f3k==false

    elseif (viewlast==true) then
      if (f3k==false) then
        drawText(3,1, date_txt[1], FONT_MINI)

        txt_w = getTextWidth(FONT_BOLD, Flts_txt[1])
        drawText(145-txt_w, 17, Flts_txt[1], FONT_BOLD)

        drawLine(4, 41, 146, 41)

        drawText(3,44, date_txt[3], FONT_MINI)

        txt_w = getTextWidth(FONT_MINI, Flts_txt[3])
        drawText(145-txt_w, 54, Flts_txt[3], FONT_MINI)
      else
        txt_w = getTextWidth(FONT_BOLD, Flts_txt[1])
        drawText(145-txt_w, 0, Flts_txt[1], FONT_BOLD)

        txt_w = getTextWidth(FONT_MINI, Lnchs_txt[1])
        drawText(145-txt_w, 19, Lnchs_txt[1], FONT_MINI)

        drawLine(4, 34, 146, 34)

        drawText(3,36, date_txt[3], FONT_MINI)

        txt_w = getTextWidth(FONT_MINI, Flts_txt[3])
        drawText(145-txt_w, 45, Flts_txt[3], FONT_MINI)

        txt_w = getTextWidth(FONT_MINI, Lnchs_txt[3])
        drawText(145-txt_w, 55, Lnchs_txt[3], FONT_MINI)
      end --f3k==false

    end --viewlast==false
  end

end


local function FltLgTele2()     --Seasons Flights/Launches
  local y

  drawLine(4, 26, 146, 26)
  drawText(75-getTextWidth(FONT_MINI, date_txt[1])/2, 0, date_txt[1], FONT_MINI)


  if (f3k==false) then
    drawLine(75, 30, 75, 65)
    drawText(75-getTextWidth(FONT_NORMAL, Flts_txt[2])/2, 7, Flts_txt[2], FONT_BOLD)

    y = 0
    for i=1, 4 do
      if (Year[i]~="" and Year[i]~=nil) then
        drawText(16, 26+(y*10), Season_txt[i], FONT_MINI)
        y = y + 1
      end
    end
    y = 0
    for i=5, 8 do
      if (Year[i]~="" and Year[i]~=nil) then
        drawText(91, 26+(y*10), Season_txt[i], FONT_MINI)
        y = y + 1
      end
    end

  elseif(f3k==true) then
    drawText(75-getTextWidth(FONT_NORMAL, Lnchs_txt[2])/2, 8, Lnchs_txt[2], FONT_BOLD)
    y = 0
    for i=1, 4 do
      if (Year[i]~="" and Year[i]~=nil) then
        drawText(20, 26+(y*10), Season_txt[i], FONT_MINI)
        y = y + 1
      end
    end



  end





end
--Draw App TELEMETRY WINDOW-----------------------------------------------------
--------------------------------------------------------------------------------





--------------------------------------------------------------------------------
--The LOOP----------------------------------------------------------------------
local function loop()

  --Flights
  if (Flts_sw and 1==system.getInputsVal(Flts_sw) and Flts_Counted==false) then
    local pSave = system.pSave
    local Txdate = system.getDateTime()

    local day_now = Txdate.day.."."..Txdate.mon.."."..Txdate.year

    --APP Testing----------------------------------------
    --[[
      -- EMU Date allways 1.3.2012
      day_now   = emu_day.."."..emu_mon.."."..emu_year
      year_now  = emu_year
    --]]
    --APP Testing----------------------------------------





    Flts_Day = Flts_Day + 1
    Flts_Tot = Flts_Tot + 1
    Flts_Year[1] = Flts_Year[1] + 1

    pSave("day_last", day_now)
    pSave("Flts_Day", Flts_Day)
    pSave("Flts_Tot", Flts_Tot)
    pSave("Flts_Year1", Flts_Year[1])

    Flts_txt[1] = lang_FltLg.flts..Flts_Day.." : "..Flts_Tot
    Flts_txt[2] = lang_FltLg.flts.." "..Flts_Tot
    Lnchs_txt[2] = lang_FltLg.f..Flts_Tot.." "..lang_FltLg.l..Lnchs_Tot

    if (f3k==false) then
      Season_txt[1] = Year[1]..": "..Flts_Year[1]
    elseif (f3k==true) then
      Season_txt[1] = Year[1]..":  "..lang_FltLg.f..convert(Flts_Year[1], false).."   "..lang_FltLg.l..convert(Lnchs_Year[1], true)
    end

    Flts_Counted = true
  end

  --Launches (f3K only)
  if (f3k) then
    if (Lnchs_sw and 1==system.getInputsVal(Lnchs_sw) and Lnchs_Counted==false) then
      local pSave = system.pSave

      Lnchs_Day = Lnchs_Day + 1
      Lnchs_Tot = Lnchs_Tot + 1
      Lnchs_Year[1] = Lnchs_Year[1] + 1


      pSave("Lnchs_Day", Lnchs_Day)
      pSave("Lnchs_Tot", Lnchs_Tot)
      pSave("Lnchs_Year1", Lnchs_Year[1])


      Lnchs_txt[1] = lang_FltLg.lnchs..Lnchs_Day.." : "..Lnchs_Tot
      Lnchs_txt[2] = lang_FltLg.f..Flts_Tot.." "..lang_FltLg.l..Lnchs_Tot
      Season_txt[1] = Year[1]..":  "..lang_FltLg.f..convert(Flts_Year[1], false).."   "..lang_FltLg.l..convert(Lnchs_Year[1], true)


      Lnchs_Counted = true
    elseif (Lnchs_sw and -1==system.getInputsVal(Lnchs_sw) and Lnchs_Counted==true) then
      Lnchs_Counted = false
    end
  end

collectgarbage()
end
--The LOOP----------------------------------------------------------------------
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
--App INITIALIZATION------------------------------------------------------------------
local function init()
  local pLoad = system.pLoad
  local pSave = system.pSave
  local insert = table.insert
  local Txdate = system.getDateTime()

  local day_now = Txdate.day.."."..Txdate.mon.."."..Txdate.year
  local day_last = pLoad("day_last", "")

  local year_last = pLoad("year_last", "")

  year_now = Txdate.year


  system.registerForm(1,MENU_APPS, lang_FltLg.appName, FltLgForm, keyPressed)
  system.registerTelemetry(1,lang_FltLg.appName.." "..lang_FltLg.day, 0, FltLgTele1)
  system.registerTelemetry(2,lang_FltLg.appName.." "..lang_FltLg.yrs, 2, FltLgTele2)


--APP Testing----------------------------------------
--[[
  -- EMU Date allways 1.3.2012

  emu_day  = 11    -- 1
  emu_mon  = 8    -- 3
  emu_year = 2020 -- 2012

  day_now   = emu_day.."."..emu_mon.."."..emu_year
  year_now  = emu_year


  print("Last "..day_last)
  print("Now "..day_now)
--]]
--APP Testing----------------------------------------


  Seasons = 0
  Flts_Year, Lnchs_Year, Year, Season_txt = {nil}, {nil}, {nil}, {nil}

  Flts_sw = pLoad("Flts_sw")
  Lnchs_sw = pLoad("Lnchs_sw")
  Flts_Day = pLoad("Flts_Day", 0)
  Lnchs_Day = pLoad("Lnchs_Day", 0)
  Flts_Tot = pLoad("Flts_Tot", 0)
  Lnchs_Tot = pLoad("Lnchs_Tot", 0)

  date_start = pLoad("date_start", "")
  --If Date has never been saved by user in the Form --> use current Tx Date
  if (date_start=="") then
    date_start = day_now
  end

  f3k = pLoad("f3k", false)
  if (f3k=="true") then
      f3k = true
    else
      f3k = false
  end

  bkp = pLoad("bkp", false)
  if (bkp=="true") then
      bkp = true
    else
      bkp = false
  end

  viewlast = pLoad("viewlast", false)
  if (viewlast=="true") then
      viewlast = true
    else
      viewlast = false
  end



  if (day_last==day_now) then         --Same DAY
    --Text Output for Last Time Flights
    Flts_txt[3] = pLoad("Flts_txt3",lang_FltLg.flts)
    Lnchs_txt[3] = pLoad("Lnchs_txt3",lang_FltLg.lnchs)
    date_txt[3] = pLoad("date_txt3",lang_FltLg.last)


    --print("SAME date")
  else                                --Diff DAY
    --Text Output for Last Time Flights
    Flts_txt[3] = lang_FltLg.flts..Flts_Day
    Lnchs_txt[3] = lang_FltLg.lnchs..Lnchs_Day
    date_txt[3] = lang_FltLg.last..day_last
    pSave("Flts_txt3",Flts_txt[3])
    pSave("Lnchs_txt3",Lnchs_txt[3])
    pSave("date_txt3",date_txt[3])

    --print("DIFF date. Last Flight:")
    --print(date_txt[3], Flts_txt[3], Lnchs_txt[3])
    Flts_Day = 0
    Lnchs_Day = 0
  end

  if (year_last==year_now) then       --Same YEAR
    for i = 1, 8 do
      Year[i] = pLoad("Year"..i, "")
      Flts_Year[i] = pLoad("Flts_Year"..i, "")
      if (f3k==true) then
        Lnchs_Year[i] = pLoad("Lnchs_Year"..i, "")
      else
        Lnchs_Year[i] = 0
      end
    end

  else                                --Diff YEAR
    Flts_Year[1] = 0
    Lnchs_Year[1] = 0
    Year[1] = year_now
    pSave ("year_last", year_now)
    for i = 1, 8 do   --Move everything up by 1 Position (Old Pos 8 gets discarted!!)
      if (Year[i]~="") then
          insert (Flts_Year, pLoad("Flts_Year"..i, ""))
          insert (Lnchs_Year, pLoad("Lnchs_Year"..i, ""))
          insert (Year, pLoad("Year"..i, ""))
      end
    end

    for i = 1, 8 do
      if (Year[i]~="") then
        pSave("Flts_Year"..i, Flts_Year[i])
        pSave("Lnchs_Year"..i, Lnchs_Year[i])
        pSave("Year"..i, Year[i])
      end
    end

    if (year_last~="" and bkp==true and f3k==false) then
      saveLineLogData(Year[2]..": "..Flts_Year[2])
    elseif (year_last~="" and bkp==true and f3k==true) then
      saveLineLogData(Year[2]..": "..Flts_Year[2].." "..Lnchs_Year[2])
    end

  end


  Flts_txt[1] = lang_FltLg.flts..Flts_Day.." : "..Flts_Tot
  Lnchs_txt[1] = lang_FltLg.lnchs..Lnchs_Day.." : "..Lnchs_Tot
  Flts_txt[2] = lang_FltLg.flts.." "..Flts_Tot
  Lnchs_txt[2] = lang_FltLg.f..Flts_Tot.." "..lang_FltLg.l..Lnchs_Tot
  date_txt[1] = lang_FltLg.since..date_start


  for i = 1, 8 do
    if (f3k==false and Year[i]~="") then
      Season_txt[i] = Year[i]..": "..Flts_Year[i]
    elseif (f3k==true and Year[i]~="") then
      Season_txt[i] = Year[i]..":  "..lang_FltLg.f..convert(Flts_Year[i], false).."   "..lang_FltLg.l..convert(Lnchs_Year[i], true)
    end
  end


  --[[--Test
  print("AT STARTUP Tx Loaded:")
  for i = 1, 10 do print (i, Year[i], Flts_Year[i], Lnchs_Year[i]) end
  --]]



end
--------------------------------------------------------------------------------
Flts_ver = "1.0"

getTranslation()
collectgarbage()
return {init=init, loop=loop, author="Rodrigo", version=Flts_ver, name=lang_FltLg.appName}
